Subject: Re: [PATCH 10/10] t/t9001-send-email.sh: get rid of unnecessary backquotes

From: Johannes Sixt <[email-masked]>
Date: Fri, 8 Jan 2016 21:07:48 +0100

Am 08.01.2016 um 12:06 schrieb Elia Pinto:
> Instead of making the shell expand 00* and invoke 'echo' with it,
> and then capturing its output as command substitution, just use
> the result of expanding 00* directly.
>
> Signed-off-by: Elia Pinto <[email-masked]>
> ---
>   t/t9001-send-email.sh | 2 +-
>   1 file changed, 1 insertion(+), 1 deletion(-)

I notices there are two patches in this series that touch 
t/t9001-send-email.sh. The other one is 9/10, and it claims to be an 
automated conversion. But that cannot be true because it would have 
removed the backquotes that are addressed in this patch.

>
> diff --git a/t/t9001-send-email.sh b/t/t9001-send-email.sh
> index 05949a1..bcbed38 100755
> --- a/t/t9001-send-email.sh
> +++ b/t/t9001-send-email.sh
> @@ -1488,7 +1488,7 @@ test_cover_addresses () {
>   	clean_fake_sendmail &&
>   	rm -fr outdir &&
>   	git format-patch --cover-letter -2 -o outdir &&
> -	cover=`echo outdir/0000-*.patch` &&

This expands the pattern and stores the result in $cover, provided there 
exists at least one file that matches the pattern. If such file does not 
exist, the pattern is stored verbatim in $cover.

> +	cover="outdir/0000-*.patch" &&

This does not expand the pattern and stores the pattern verbatim in $cover.

>   	mv $cover cover-to-edit.patch &&

This line succeeds because there pattern is expanded and matches only 
one file.

>   	perl -pe "s/^From:/$header: extra\@address.com\nFrom:/" cover-to-edit.patch >"$cover" &&

In this line, "$cover" is not expanded, and a file named '0000-*.patch' 
will be dropped into subdirectory 'outdir'.

>   	git send-email \

The command that is truncated here looks like this:

         git send-email \
                 --force \
                 --from="Example <[email-masked]>" \
                 --no-to --no-cc \
                 "$@" \
                 --smtp-server="$(pwd)/fake.sendmail" \
                 outdir/0000-*.patch \
                 outdir/0001-*.patch \
                 outdir/0002-*.patch \
                 2>errors >out &&

Since it uses a pattern that would match a the oddly named file and 
since at this point the original 0000-whatever* file was moved away, the 
pattern still matches only one 0000-* file. The test still succeeds, so 
you did not notices that it has now slightly different behavior.

As much as I would like to remove a sub-process, I think it is better to 
keep the $(echo 0000-*) in this case.